datablock ParticleData(SunSpectreParticleA)
{
	dragCoefficient = "0";
	windCoefficient = "0";
	gravityCoefficient = "0";
	inheritedVelFactor = "0";
	constantAcceleration = "0";
	lifetimeMS = "500";
	lifetimeVarianceMS = "200";
	spinSpeed = "0";
	spinRandomMin = "-90";
	spinRandomMax = "90";
	useInvAlpha = "0";
	animateTexture = "0";
	framesPerSec = "1";
	textureName = "./epicorb";
	animTexName[0] = "./epicorb";
	colors[0] = "0.2 0.2 0.2 1";
	colors[1] = "0.18 0.18 0.18 0.9";
	colors[2] = "0 0 0 0";
	colors[3] = "0 0 0 0";
	sizes[0] = "1";
	sizes[1] = "0.1";
	sizes[2] = "0";
	sizes[3] = "0";
	times[0] = "0.1";
	times[1] = "1";
	times[2] = "0";
	times[3] = "0";
};

datablock ParticleEmitterData(SunSpectreEmitterA)
{
	ejectionPeriodMS = "1";
	periodVarianceMS = "0";
	ejectionVelocity = "2";
	velocityVariance = "1";
	ejectionOffset = "0.7";
	thetaMin = "0";
	thetaMax = "180";
	phiReferenceVel = "0";
	phiVariance = "360";
	overrideAdvance = "0";
	orientParticles = "0";
	orientOnVelocity = "1";
	particles = "SunSpectreParticleA";
	lifetimeMS = "0";
	lifetimeVarianceMS = "0";
	useEmitterSizes = "0";
	useEmitterColors = "0";
	uiName = "Sun Spectre Teleport A";
	doFalloff = "0";
	doDetail = "0";
};

datablock ExplosionData(SunSpectreExplosion : PlayerTeleportExplosion)
{
	emitter[0] = "SunSpectreEmitterA";

	damageRadius = 0;
	impulseForce = 0;
	impulseRadius = 0;
	radiusDamage = 0;
};

datablock ProjectileData(SunSpectreProjectile : PlayerTeleportProjectile)
{
	Explosion = "SunSpectreExplosion";
	uiName = "Sun Spectre Teleport";

	damageRadius = 0;
	directDamage = 0;
	radiusDamage = 0;
};

deactivatepackage(SunSpectrePackage);
if(!isFunction("servercmdhelp"))
{
	exec("./help.cs");
}
package SunSpectrePackage
{
	function Player::teleportEffect(%this)
	{
		%proj = new projectile()
		{
			datablock = SunSpectreProjectile;
			initialposition = vectorAdd(%this.position,"0 0" SPC getWord(%this.getObjectBox(),5)/8);
			initialVelocity = "0 0 1";
			rotation = "1 0 0 0";
			scale = "1 1 1";
			sourceobject = -1;
			sourceslot = 0;
			position = vectorAdd(%this.position,"0 0" SPC getWord(%this.getObjectBox(),5)/8);

			originpoint = vectorAdd(%this.position,"0 0" SPC getWord(%this.getObjectBox(),5)/8);
		};
		%proj.schedule(0,"explode");
		return;
	}
	function Vehicle::teleportEffect(%this)
	{
		%proj = new projectile()
		{
			datablock = SunSpectreProjectile;
			initialposition = vectorAdd(%this.position,"0 0" SPC getWord(%this.getObjectBox(),5)/8);
			initialVelocity = "0 0 1";
			rotation = "1 0 0 0";
			scale = "1 1 1";
			sourceobject = -1;
			sourceslot = 0;
			position = vectorAdd(%this.position,"0 0" SPC getWord(%this.getObjectBox(),5)/8);

			originpoint = vectorAdd(%this.position,"0 0" SPC getWord(%this.getObjectBox(),5)/8);
		};
		%proj.schedule(0,"explode");
		return;
	}
	function servercmdDropCameraAtPlayer(%client)
	{
		if(%client.isAdmin || %client.isSuperAdmin || %client.isStaff)
		{
			if(isObject(%player = %client.player))
				%client.camera.setTransform(%player.getEyeTransform());
			%client.setControlObject(%client.camera);
			%client.camera.setMode("Observer");
			if(isObject(%player))
			{
				%player.client = "";
				%client.player = "";
				%client.lastplayer = %player;
				%player.sunCollapseObservers();
			}
		}
	}
	function servercmdDropPlayerAtCamera(%client)
	{
		if(%client.isAdmin || %client.isSuperAdmin || %client.isStaff)
		{
			if(!isObject(%client.camera))
			{
				%client.instantrespawn();
				return;
			}
			if(!isObject(%player = %client.lastplayer))
			{
				commandtoclient(%client,'CenterPrint',"\c6No possession.",1);
				return;
			}

			%moveobj = %player;
			while(isObject(%moveobj.getObjectMount()))
			{
				%moveobj = %moveobj.getObjectMount();
			}

			%trans = %client.camera.getTransform();
			%trans = setWord(%trans,2,getWord(%trans,2) + %moveobj.eyeVertOffset);
			%moveobj.setTransform(%trans);
			%moveobj.setVelocity("0 0 0");
			%client.lastplayer.schedule(36,"teleportEffect");
			if(%client.camera.ignoreLastTag)
			{
				%client.possessObject = %client.lastplayer;
			}
		}
	}
	function GameConnection::onClientEnterGame(%client)
	{
		Parent::onClientEnterGame(%client);
		if(!isObject(%camera = %client.camera))
			return;
		%camera.tool0 = nametoid(hammerItem);
		%camera.tool1 = nametoid(wrenchItem);
		%camera.tool2 = nametoid(printGun);
		%camera.client = %client;
		%camera.spraycan = -1;
		%camera.sprayfxCan = -1;
		%camera.currTool = -1;
		%camera.usingbrick = 0;
		//%camera.tool3 = deleteGunItem;
	}
	function GameConnection::setControlObject(%client,%object)
	{
		for(%i=0;%i<30;%i++)
		{
			messageclient(%client,'MsgItemPickup','',%i,0,1);
		}
		Parent::setControlObject(%client,%object);
		servercmdisFirstPersonOrb(%client);
		if(!isObject(%object))
			return;
		for(%i=0;%i<30;%i++)//why would you need 10 tools? idk man, i gotta set the limit somewhere
		{
			if(%object.tool[%i]$="")
				break;
			messageclient(%client,'MsgItemPickup','',%i,%object.tool[%i],1);
		}
		if(%object.getClassName()$="Camera")
		{
			if(!isObject(%client.lastplayer)||%client.lastplayer.getDamageState()$="Disabled")
			{
				%client.lostControlTime = getSimTime();
				if(%client.isAdmin||%client.isSuperAdmin||%client.isStaff)
					%client.schedule(1500,"CenterPrint","\c6-oOo-",1);
			}
		}
	}
	function GameConnection::createPlayer(%this, %transform)
	{
		Parent::createPlayer(%this, %transform);
		%this.player.minigame = %this.minigame;
		%this.player.brickgroup = %this.brickgroup;
	}
	function Camera::isFirstPerson(%this)
	{
		return 1;//I don't want to deal with orbit mode turning it on and off, so just return 1
	}
	function servercmdupdatebodycolors(%client, %headColor, %hatColor, %accentColor, %packColor, %secondPackColor, %chestColor, %hipColor, %LLegColor, %RLegColor, %LArmColor, %RArmColor, %LHandColor, %RHandColor, %decalName, %faceName)
	{
		if(isObject(%client.player))
			%client.player.clearAvatar();
		Parent::servercmdupdatebodycolors(%client, %headColor, %hatColor, %accentColor, %packColor, %secondPackColor, %chestColor, %hipColor, %LLegColor, %RLegColor, %LArmColor, %RArmColor, %LHandColor, %RHandColor, %decalName, %faceName);
	}
	function servercmdupdatebodyparts(%client, %hat, %accent, %pack, %secondPack, %chest, %hip, %LLeg, %RLeg, %LArm, %RArm, %LHand, %RHand)
	{
		if(isObject(%client.player))
			%client.player.clearAvatar();
			Parent::servercmdupdatebodyparts(%client, %hat, %accent, %pack, %secondPack, %chest, %hip, %LLeg, %RLeg, %LArm, %RArm, %LHand, %RHand);
	}
	function Armor::onDisabled(%db,%this,%state)
	{
		Parent::onDisabled(%db,%this,%state);
		if(%this.getClassName()$="Player"||%this.getClassName()$="AIPlayer")
		{
			%this.setShapeName("",8564862);
		}
	}
	function GameConnection::applyBodyColors(%this)
	{
		if(!isObject(%player = %this.player))
			return Parent::applyBodyColors(%this);

		%player.applyBodyColors(%this);
	}
	function GameConnection::applyBodyParts(%this)
	{
		if(!isObject(%player = %this.player))
			return Parent::applyBodyParts(%this);

		%this.validateAvatarPrefs();
		%player.applyBodyParts(%this);
	}
	function getBrickGroupFromObject(%obj)//This function may not like reexecution.  Try putting it in a non-reexecutable file?
	{
		%value = Parent::getBrickGroupFromObject(%obj);
		if(!isObject(%value)&&isObject(%obj.brickGroup))
		{
			return %obj.brickGroup;
		}
	}
	function Player::clearAvatar(%this)
	{
		%this.hasAvatar = "";
	}
	function Player::applyBodyColors(%this,%client)
	{
		if(!%this.hasAvatar)
		{
			if(!isObject(%client))
				return;
			if(!%this.absorbAvatar(%client))
				return;
		}

		%this.setDecalName(%this.decalname);
		%this.setFaceName(%this.facename);
		%this.setNodeColor("headSkin", %this.headColor);
		if($Accent[%this.accent]!$="none")
			%this.setNodeColor($Accent[%this.accent], %this.accentColor);
		if($Chest[%this.chest]!$="none")
			%this.setNodeColor($Chest[%this.chest], %this.chestColor);
		if($Hat[%this.hat]!$="none")
			%this.setNodeColor($Hat[%this.hat], %this.hatColor);
		if($Hip[%this.hip]!$="none")
			%this.setNodeColor($Hip[%this.hip], %this.hipColor);
		if($Larm[%this.larm]!$="none")
			%this.setNodeColor($Larm[%this.larm], %this.larmColor);
		if($Lhand[%this.lhand]!$="none")
			%this.setNodeColor($Lhand[%this.lhand], %this.lhandColor);
		if($Lleg[%this.lleg]!$="none")
			%this.setNodeColor($Lleg[%this.lleg], %this.llegColor);
		if($Pack[%this.pack]!$="none")
			%this.setNodeColor($Pack[%this.pack], %this.packColor);
		if($Rarm[%this.rarm]!$="none")
			%this.setNodeColor($Rarm[%this.rarm], %this.rarmColor);
		if($Rhand[%this.rhand]!$="none")
			%this.setNodeColor($Rhand[%this.rhand], %this.rhandColor);
		if($Rleg[%this.rleg]!$="none")
			%this.setNodeColor($Rleg[%this.rleg], %this.rlegColor);
		if($SecondPack[%this.secondPack]!$="none")
			%this.setNodeColor($SecondPack[%this.secondPack], %this.secondPackColor);
	}
	function Player::applyBodyParts(%this,%client)
	{
		if(!%this.hasAvatar)
		{
			if(!isObject(%client))
				return;
			if(!%this.absorbAvatar(%client))
				return;
		}

		hideAllNodes(%this);
		%this.unhideNode($Accent[%this.accent]);
		%this.unhideNode($Chest[%this.chest]);
		%this.unhideNode($Hat[%this.hat]);
		%this.unhideNode($Hip[%this.hip]);
		%this.unhideNode($Larm[%this.larm]);
		%this.unhideNode($Lhand[%this.lhand]);
		%this.unhideNode($Lleg[%this.lleg]);
		%this.unhideNode($Pack[%this.pack]);
		%this.unhideNode($Rarm[%this.rarm]);
		%this.unhideNode($Rhand[%this.rhand]);
		%this.unhideNode($Rleg[%this.rleg]);
		%this.unhideNode($SecondPack[%this.secondPack]);
	}
	function Player::absorbAvatar(%this,%client)
	{
		//We require that we clear the old avatar before absorbing a new one.
		//This allows us to avoid ALWAYS using the client's avatar.
		if(%this.hasAvatar)
			return 0;
		if(!isObject(%client))
			return 0;

		%this.decalName = %client.decalName;
		%this.faceName = %client.faceName;

		%this.accent = %client.accent;
		%this.chest = %client.chest;
		%this.hat = %client.hat;
		//no head shape option
		%this.hip = %client.hip;
		%this.larm = %client.larm;
		%this.lhand = %client.lhand;
		%this.lleg = %client.lleg;
		%this.pack = %client.pack;
		%this.rarm = %client.rarm;
		%this.rhand = %client.rhand;
		%this.rleg = %client.rleg;
		%this.secondPack = %client.secondPack;

		%this.accentColor = %client.accentColor;
		%this.chestColor = %client.chestColor;
		%this.hatColor = %client.hatColor;
		%this.headColor = %client.headColor;
		%this.hipColor = %client.hipColor;
		%this.larmColor = %client.larmColor;
		%this.lhandColor = %client.lhandColor;
		%this.llegColor = %client.llegColor;
		%this.packColor = %client.packColor;
		%this.rarmColor = %client.rarmColor;
		%this.rhandColor = %client.rhandColor;
		%this.rlegColor = %client.rlegColor;
		%this.secondPackColor = %client.secondPackColor;

		%this.hasAvatar = 1;
		return 1;
	}
	function servercmdisFirstPersonOrb(%client)
	{
		if(!isObject(%CO = %client.getControlObject()))
			return;
		if(%CO.getClassName()$="Camera")
			%isFP = %CO.isFirstPerson();
		else
			%isFP = 0;
		commandtoclient(%client,'isFirstPersonOrb',%isFP);
	}
	function servercmdusetool(%client, %slot)
	{
		Parent::servercmdusetool(%client, %slot);
		if(!isObject(%camera = %client.getControlObject()))
			return;
		if(%camera.getClassName()$="Camera")
		{
			%camera.currTool = %slot;
			%camera.spraycan = -1;
			%camera.sprayfxCan = -1;
			%camera.usingBrick = 0;
		}
	}
	function servercmdunusetool(%client)
	{
		Parent::servercmdunusetool(%client);
		if(!isObject(%camera = %client.getControlObject()))
			return;
		if(%camera.getClassName()$="Camera")
		{
			%camera.currTool = -1;
			%camera.usingBrick = 0;
			%camera.spraycan = -1;
			%camera.sprayfxCan = -1;
		}
	}
	function servercmduseinventory(%client,%slot)
	{
		Parent::servercmduseinventory(%client,%slot);
		if(!isObject(%camera = %client.getControlObject()))
			return;
		if(%camera.getClassName()!$="Camera")
			return;
		%camera.usingbrick = 1;
		if(isObject(%tempbrick = %camera.tempbrick))
		{
			if(isObject(%newdb = %client.inventory[%slot]))
			{
				if(%newdb!=%tempbrick.getDatablock())
					%tempbrick.setDatablock(%newdb);
			}
		}
	}
	function BrickDeployProjectile::onCollision(%db, %proj, %col, %fade, %pos, %normal)
	{
		if(isObject(%client = %proj.client))
		{
			if((%camera = %client.getControlObject())==%proj.sourceObject)
			{
				if(%camera.getClassName()$="Camera")
				{
					%playerswitch = 1;
					%oldplayer = %client.player;
					%client.player = %camera;
				}
			}
		}
		Parent::onCollision(%db, %proj, %col, %fade, %pos, %normal);
		if(%playerswitch)
			%client.player = %oldplayer;
	}
	function serverCmdRotateBrick(%client,%val)
	{
		if(isObject(%camera = %client.getControlObject()))
		{
			if(%camera.getClassName()$="Camera")
			{
				%ps = 1;
				%oldplayer = %client.player;
				%client.player = %camera;
			}
		}
		Parent::serverCmdRotateBrick(%client,%val);
		if(%ps)
			%client.player = %oldplayer;
	}
	function serverCmdShiftBrick(%client, %x, %y, %z)
	{
		if(isObject(%camera = %client.getControlObject()))
		{
			if(%camera.getClassName()$="Camera")
			{
				%ps = 1;
				%oldplayer = %client.player;
				%client.player = %camera;
			}
		}
		Parent::serverCmdShiftBrick(%client, %x, %y, %z);
		if(%ps)
			%client.player = %oldplayer;
	}
	function serverCmdSuperShiftBrick(%client, %x, %y, %z)
	{
		if(isObject(%camera = %client.getControlObject()))
		{
			if(%camera.getClassName()$="Camera")
			{
				%ps = 1;
				%oldplayer = %client.player;
				%client.player = %camera;
			}
		}
		Parent::serverCmdSuperShiftBrick(%client, %x, %y, %z);
		if(%ps)
			%client.player = %oldplayer;
	}
	function servercmdCancelBrick(%client)
	{
		if(isObject(%camera = %client.getControlObject()))
		{
			if(%camera.getClassName()$="Camera")
			{
				%ps = 1;
				%oldplayer = %client.player;
				%client.player = %camera;
			}
		}
		Parent::serverCmdCancelBrick(%client);
		if(%ps)
			%client.player = %oldplayer;
	}
	function servercmdPlantBrick(%client)
	{
		if(isObject(%camera = %client.getControlObject()))
		{
			if(%camera.getClassName()$="Camera")
			{
				%ps = 1;
				%oldplayer = %client.player;
				%client.player = %camera;
			}
		}
		Parent::serverCmdPlantBrick(%client);
		if(%ps)
			%client.player = %oldplayer;
	}
	function serverCmdUseSprayCan(%client, %index)
	{
		if(isObject(%camera = %client.getControlObject()))
		{
			if(%camera.getClassName()$="Camera")
			{
				%camera.spraycan = %index;
				%camera.sprayfxCan = -1;
				%camera.usingBrick = 0;
				if(isObject(%camera.tempbrick))
					%camera.tempbrick.setColor(%index);
				return;
			}
		}
		Parent::serverCmdUseSprayCan(%client, %index);
	}
	function serverCmdUseFxCan(%client, %index)
	{
		if(isObject(%camera = %client.getControlObject()))
		{
			if(%camera.getClassName()$="Camera")
			{
				%camera.spraycan = -1;
				%camera.sprayfxCan = %index;
				%camera.usingBrick = 0;
				return;
			}
		}
		Parent::serverCmdUseFxCan(%client, %index);
	}
	function serverCmdBuyBrick(%client, %slot, %db)
	{
		if(%client.getControlObject()==%client.camera)
			messageclient(%client, 'MsgSetInvData', "", %slot, %db);
		else
			Parent::serverCmdBuyBrick(%client, %slot, %db);
	}
	function Observer::onTrigger(%db, %this, %slot, %value)
	{
		if(!isObject(%client = %this.getControllingClient()))
			Parent::onTrigger(%db, %this, %slot, %value);
		%oldplayer = %client.player;
		%client.player = %this;
		Parent::onTrigger(%db, %this, %slot, %value);
		%client.player = %oldplayer;
		if(!%client.isAdmin && !%client.isSuperAdmin && !%client.isStaff)
		{
			if(isObject(%this.getOrbitObject().getControllingClient()))
				return;
			else
				return Parent::onTrigger(%db, %this, %slot, %value);
		}

		if((%timeout = (getSimTime()-%client.lostControlTime))<1500&&%slot!=3)
		{
			commandtoclient(%client,'CenterPrint',"\c6Lost Control Timeout: "@(1500-%timeout),2);
			return;
		}
		if(%value)
		{
			if(%slot==0)
			{
				%client.possessObject = "";
				if(%this.usingBrick)
				{
					brickImage.onFire(%this,0);
				}
				if(%this.spraycan>=0)
				{
					nametoid("color"@%this.spraycan@"SprayCanImage").onFire(%this,0);
				}
				if(%this.sprayFxCan>=0)
				{
					switch (%this.sprayFxCan)
					{
						case 0:
							flatSprayCanImage.onFire(%this,0);
						case 1:
							pearlSprayCanImage.onFire(%this,0);
						case 2:
							chromeSprayCanImage.onFire(%this,0);
						case 3:
							glowSprayCanImage.onFire(%this,0);
						case 4:
							blinkSprayCanImage.onFire(%this,0);
						case 5:
							swirlSprayCanImage.onFire(%this,0);
						case 6:
							rainbowSprayCanImage.onFire(%this,0);
						case 7:
							stableSprayCanImage.onFire(%this,0);
						case 8:
							jelloSprayCanImage.onFire(%this,0);
					}
				}
				if(%this.currTool!$=""&&%this.currTool>=0)
				{
					if(isObject(%tool = %this.tool[%this.currTool]))
					{
						if(%tool.getName()$="wrenchItem")
						{
							WrenchImage.onFire(%this, 0);
								////Use the following if you want increased range.
								////cast range is ~9.75 by default, but the camera is really fast, so let's try 19.5
								//%cast = containerRaycast(%this.getEyePoint(),vectorAdd(%this.getEyePoint(),vectorScale(%this.getEyeVector(),19.5)), $TypeMasks::FxBrickAlwaysObjectType|$TypeMasks::StaticShapeObjectType|$TypeMasks::StaticTSObjectType);
								//if(isObject(%hitobj = getWord(%cast,0)))
								//{
								//	%hitpos = getWords(%cast,1,3);
								//	%hitvector = getWords(%cast,4,6);
								//	%proj = new Projectile()
								//	{
								//		dataBlock = wrenchProjectile;
								//		initialPosition = %hitpos;
								//		initialVelocity = vectorScale(%hitvector,-50);
								//		position = %hitpos;
								//		scale = "1 1 1";
								//		sourceObject = %this;
								//		sourceSlot = 0;
								//		client = %client;
								//		originpoint = %hitpos;
								//	};
								//	%proj.schedule(0,"explode");
								//	WrenchImage.onHitObject(%this, 0, %hitobj, %hitpos, %hitvector);
								//}
						}
						if(%tool.getName()$="PrintGun")
						{
							PrintGunImage.onFire(%this,0);
							//talk("yer printin a letter");
						}
						if(%tool.getName()$="hammerItem")
						{
							hammerImage.onFire(%this,0);
							//talk("yer usin a hammer");
						}
					}
				}
			}
			if(%slot==3)
				%this.ignoreLastTag = 1;
		}
		else
		{
			if(%slot==3)
			{
				%this.ignoreLastTag = 0;
				if(%client.possessObject)
				{
					%client.possessObject(%client.possessObject);
					%client.possessObject = "";
				}
			}
			if(%slot==0)
			{
				if((%this.currTool$=""||%this.currTool<0)&&%this.usingbrick!=1&&%this.spraycan<0&&%this.sprayFxcan<0)
				{
					%cast = containerRaycast(%this.getEyePoint(), vectorAdd(%this.getEyePoint(),vectorScale(%this.getEyeVector(),100)), $TypeMasks::PlayerObjectType|$TypeMasks::VehicleObjectType);
					if(!isObject(%obj = getWord(%cast,0)))
						return;
					if(!%this.ignoreLastTag)
					{
						if(%obj==%client.lastplayer)
						{
							%casttwo = containerRaycast(%this.getEyePoint(), vectorAdd(%this.getEyePoint(),vectorScale(%this.getEyeVector(),100)), $TypeMasks::PlayerObjectType|$TypeMasks::VehicleObjectType,%client.lastplayer);
							if(!isObject(%obj = getWord(%casttwo,0)))
							{
								%objx = containerFindFirst($TypeMasks::PlayerObjectType|$TypeMasks::VehicleObjectType,(%containerpos = getWords(%cast,1,3)),5,5,5);
								%closest = 9;//mceil(msqrt(5^2 + 5^2 + 5^2))
								while(isObject(%objx))
								{
									if((%dist = vectorDist(%containerpos,%objx.getEyePoint()))<%closest&&%objx!=%player)
									{
										%closest = %dist;
										%obj = %objx;
									}
									%objx = containerFindNext();
								}
								//echo(%obj@"|"@%closest@"|"@%obj.getShapeName());
								if(%obj==%client.lastplayer)
									return;
							}
						}
					}

					if(%this.ignoreLastTag)
						%client.possessObject = %obj;
					else
						%client.possessObject(%obj);
				}
			}
			if(%slot==4)
			{
				%trans = %this.getTransform();
				commandtoclient(%client,'ClearCenterPrint');
				%client.createplayer(%this.getTransform());
				%this.setTransform(%trans);
				%client.lastPlayer = %client.player;
				%client.player.minigame = %client.minigame;
				%client.player.brickgroup = %client.brickgroup;
				if(!%this.ignoreLastTag)
				{
					%client.setControlObject(%this);
					%client.player.client = "";
					%client.lastplayer = %client.player;
					%client.player = "";
				}
			}
		}
	}
	function GameConnection::PossessObject(%client, %obj)
	{
		if(!isObject(%obj))
		{
			commandtoclient(%client,'CenterPrint',"\c6The object died. :c");
			return;
		}

		if((%namestring = %obj.getdataBlock().label)$="") if((%namestring = %obj.getShapeName())$="") %namestring = %obj.getDatablock().getname();//this shit is so fucked up, lol
		commandtoclient(%client,'CenterPrint',"\c6"@%namestring,1);

		%client.lastPlayer = %obj;
		//Bump old client to observer.
		%obj.sunBumpClient();
		//Push ourselves as controller.
		%obj.sunPushClient(%client);
		%obj.minigame = %client.minigame;
		%obj.brickgroup = %client.brickgroup;
	}
	function ShapeBase::sunBumpClient(%this)
	{
		if(isObject(%controller = %this.getControllingObject()))//First bump any drivers.
			%controller.clearcontrolobject();

		if(!isObject(%client = %this.client = %this.getControllingClient()))
			return;

		if(isObject(%player = %client.player))
		{
			if(%player!=%this)//This client does not own this object, so bump them back to their player. (This can happen when other mods use setControlObject)
			{
				%count = mAbs(%player.SunCount);
				for(%i=%count;%i>=1;%i--)
				{
					%player.Sun[%i+1] = %player.Sun[%i];
				}
				%player.Sun[1] = %client;
				%player.SunCount++;
				%client.lastPlayer = %player;
				if(!isObject(%controller = %player.getControllingClient()))
				{
					%player.sunPushClient(%client);
					return;
				}
				if(%controller == %client)
				{
					%player.sunPushClient(%client);
					return;
				}
				%client.setControlObject(%client.camera);
				%client.camera.setOrbitMode(%player, "0 0 0 1 0 0 0", 5, 10, 5, 0);
				%client.player = "";
				return;
			}
		}


		%count = mAbs(%this.SunCount);
		for(%i=%count;%i>=1;%i--)//Bump Observer list up to make room.
		{
			%this.Sun[%i+1] = %this.Sun[%i];
		}
		%this.Sun[1] = %client;
		%this.SunCount++;
		%client.lastPlayer = %this;
		%client.setControlObject(%client.camera);
		%client.camera.setOrbitMode(%this, "0 0 0 1 0 0 0", 5, 10, 5, 0);
		%this.client = "";
		%client.player = "";
	}
	function ShapeBase::sunPushClient(%this,%client)
	{
		if(isObject(%this.getControllingClient()))
		{
			messageAll('',"\c0Something has gone horribly wrong! This body contains a sun? How did that happen?"@%this@"|"@%client@"|"@%this.getControllingClient());
			return;
		}
		%this.client = %client;
		%client.player = %this;
		%client.lastplayer = %this;
		%client.setControlObject(%this);
	}
	function ShapeBase::sunCollapseObservers(%this)
	{
		if(isObject(%client = %this.client = %this.getControllingClient()))
		{
			messageAll('',"\c0Something has gone horribly wrong! This body is still possessed? How did that happen?"@%this@"|"@%this.getControllingClient());
			return;
		}

		%count = mAbs(%this.SunCount);
		for(%i=1;%i<=%count;%i++)
		{
			%client = %this.Sun[%i];
			if(%client.lastplayer==%this&&%client.camera.getOrbitObject()==%this)
				break;
			%client = "";
		}
		if(!isObject(%client))//We found no applicable client.
		{
			%this.SunCount = 0;
			return;
		}

		%client.player = %this;
		%this.client = %client;
		%client.setControlObject(%this);

		//Now do the collapse.
		for(%i=1;%i<=%count;%i++)
		{
			for(%x=%i;%x<=%count;%x++)
			{
				if(isObject(%subClient = %this.Sun[%x]))
				{
					if(%subClient!=%client&&%subClient.lastPlayer==%this&&%subClient.camera.getOrbitObject()==%this)
					{
						%this.Sun[%x] = "";
						%this.Sun[%i] = %subClient;
						%y++;
					}
				}
			}
		}
		%this.SunCount = mAbs(%y);
	}
	function Vehicle::finalExplosion(%this)
	{
		if(!isObject(%client = %this.getControllingClient()))
			return;
		if(!isObject(%client.camera))//how did this happen? oh well.
		{
			%client.instantrespawn();//We should give them a camera instead!
			return;
		}
		%client.setControlObject(%client.camera);
		%client.camera.setOrbitPointMode(%this.getWorldBoxCenter(),5);
		Parent::finalExplosion(%this);
	}
	function servercmdhelp(%client, %a, %b, %c, %d, %e, %f, %g, %h, %i, %j, %k, %l, %m, %n, %o, %p, %q, %r)
	{
		if(isFunction("servercmdhelp"))
			Parent::servercmdhelp(%client, %a, %b, %c, %d, %e, %f, %g, %h, %i, %j, %k, %l, %m, %n, %o, %p, %q, %r);
		if(%a$="")
			messageclient(%client,'',"\c6SunSpectre");
		if(%a$="SunSpectre")
		{
			messageclient(%client,'',"\c6==SunSpectre Help==");
			messageclient(%client,'',"\c6SunSpectre is a tool for using the camera to possess \c0vehicles\c6 and \c0armor\c6.");
			messageclient(%client,'',"\c6To do so, the user must be \c2admin\c6, \c2superadmin\c6, or have the \c2.isStaff flag\c6 set on their client.");
			messageclient(%client,'',"\c3F8\c6 to spawn a camera, \c3F7\c6 to move the last object you possessed to your \c2current\c6 position.");
			messageclient(%client,'',"\c3Left click\c6 to possess a \c0new\c6 object.");
			messageclient(%client,'',"\c6By default, we ignore the \c2last object\c6 possessed.  This is so that we can possess other objects from \c2inside\c6 of our last object\c6.");
			messageclient(%client,'',"\c6Hold \c3shift\c6 while \c3left clicking\c6 to include the last object in the search.");
			messageclient(%client,'',"\c6The possession will take place once both \c3shift\c6 and \c3leftclick\c6 are released.");
			messageclient(%client,'',"\c6This is so that the object you are possessing doesn't immediately start crouching and/or firing it's weapon. :P");
			messageclient(%client,'',"\c3Right click\c6 to spawn a new player.");
		}
	}
};
activatepackage(SunSpectrePackage);